/*************************************************************************
 * Processor-specific object file.  Contains SFR definitions.
 *************************************************************************/
INPUT("processor.o")

/*************************************************************************
 * For interrupt vector handling
 *************************************************************************/
/*PROVIDE(_vector_spacing = 0x00000001);*/
_ebase_address  = 0x9FC01000;

/*_min_stack_size = 100;*/

/*************************************************************************
 * Memory Address Equates
 *************************************************************************/

_RESET_ADDR              = 0xBFC00000;
_BEV_EXCPT_ADDR          = 0xBFC00380;
_DBG_EXCPT_ADDR          = 0xBFC00480;
_DBG_CODE_ADDR           = 0xBFC02000;
_DBG_CODE_SIZE           = 0xFF0     ;
_GEN_EXCPT_ADDR          = _ebase_address + 0x180;


/*************************************************************************
 * Memory Regions
 *
 * Memory regions without attributes cannot be used for orphaned sections.
 * Only sections specifically assigned to these regions can be allocated
 * into these regions.
 *************************************************************************/
MEMORY
{
  /* Modify the ORIGIN to place the module header in the absolute section*/	
  lib_module_header    (rx)  : ORIGIN = 0x9D06E000, LENGTH = 0x100
  kseg0_program_mem    (rx)  : ORIGIN = 0x9D06E100, LENGTH = 0x12000
  
  
  /* We use the linker defaults here. The following sections are not
   * used. We have added them anyways so that the linker stops
   * warning. */

  kseg0_boot_mem             : ORIGIN = 0x9FC00490, LENGTH = 0x970
  exception_mem              : ORIGIN = 0x9FC01000, LENGTH = 0x1000
  kseg1_boot_mem             : ORIGIN = 0x9FC01000, LENGTH = 0x490
  debug_exec_mem             : ORIGIN = 0xBFC02000, LENGTH = 0xFF0
  config3                    : ORIGIN = 0xBFC02FF0, LENGTH = 0x4
  config2                    : ORIGIN = 0xBFC02FF4, LENGTH = 0x4
  config1                    : ORIGIN = 0xBFC02FF8, LENGTH = 0x4
  config0                    : ORIGIN = 0xBFC02FFC, LENGTH = 0x4

  kseg1_data_mem       (w!x) : ORIGIN = 0xA001F000, LENGTH = 0xFFF
  sfrs                       : ORIGIN = 0xBF800000, LENGTH = 0x100000
/*  configsfrs                 : ORIGIN = 0xBFC02FF0, LENGTH = 0x10 */
}
/*
SECTIONS
{
	
   .Module_Header_Section : {
 		KEEP(*(.Module_Header_Section))
	} > lib_module_header
	  
	  
  .config_BFC02FF0 : {
    KEEP(*(.config_BFC02FF0))
  } > config3
  .config_BFC02FF4 : {
    KEEP(*(.config_BFC02FF4))
  } > config2
  .config_BFC02FF8 : {
    KEEP(*(.config_BFC02FF8))
  } > config1
  .config_BFC02FFC : {
    KEEP(*(.config_BFC02FFC))
  } > config0
}
*/


